// $Id: Mutex.cc,v 1.3.2.2 1998/11/17 20:54:54 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "Mutex.h"

void ResMgr::forget(Mutexer *mxer) {
	for (int i = theQueue.offset(); i < theQueue.count(); ++i) {
		if (theQueue[i] == mxer) {
			Assert(i != theQueue.offset());
			theQueue[i] = 0;
			return;
		}
	}
	//abort(); // not found XXX
}

void ResMgr::shift(ResMgr::IMethod im) {
	theQueue.dequeue(); // skip first one
	while (!theQueue.empty()) {
		// ignore disappeared users
		if (theQueue.head()) {
			(this->*im)(theQueue.head());
			return;
		} else {
			theQueue.dequeue();
		}
	}	
	// no one left
	inform(&ResOwner::idleRes, "idleRes");
}

void ResMgr::dequeueAll(ResMgr::IMethod im1, ResMgr::IMethod im) {
	if (!theQueue.empty()) {
		if (im1 && theQueue.head()) {
			(this->*im1)(theQueue.head());
		}
		theQueue.dequeue();
	}
	while (!theQueue.empty()) {
		// ignore disappeared users
		if (theQueue.head())
			(this->*im)(theQueue.head());
		theQueue.dequeue();
	}
}
