// $Id: ProgressMeter.cc,v 1.3.2.1 1998/09/22 07:43:34 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "AppDef.h"
#include "ProgressMeter.h"

#include <iostream.h>
#include <iomanip.h>

/* ProgMeterCfg */

ProgMeterCfg::ProgMeterCfg(): theMaxCcLevel(-1), theMaxStartCount(-1) { 
}


/* ProgressMeter */

ProgressMeter *ProgressMeter::clone() const {
	ProgressMeter *meter = new ProgressMeter();
	meter->configure(theCfg);
	return meter;
}

ostream &ProgressMeter::print(ostream &os) const {
	return os
		<< "started: " << setw(8) << theStartCount
		<< " finished: " << setw(8) << theFinishCount
		<< " running: " << setw(6) << ccLevel();
}
