// $Id: ReqEater.cc,v 1.12.2.4 1998/11/25 18:16:26 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "ReqEater.h"
#include "ErrHist.h"

void ReqEater::doContent() {
	assert(theCont.theReqHdr);

	IOBuffer &buf = theConn->theReaderBuf;
	if (!buf.contSize() || !theCont.theReqHdr->parse(buf.content())) {
		if (buf.eod()) {
			TheErrHist[E_EARLY_REQ_END]++;
			SysLog << "unexpected end of request; offset " << buf.outOffset() << " need: " << theMaxOffset << " near: " << endl << buf.content() << endl << '}' << ende;
			buf.consumed(buf.contSize()); // will trigger exhausted state
		}
		return;
	}

	buf.consumed(theCont.theReqHdr->hdrSize());

	if (theCont.theReqHdr->objId() <= 0) {
		TheErrHist[E_FOREIGN_REQ]++;
		SysLog << "foreign request format in " << theCont.theReqHdr->uri() << ende;
		buf.errFmt(true);
	}

	// done!
	maxOffsetHere();
	sendContChange();
}
