#ifndef _ADDR_GEN_H_
#define _ADDR_GEN_H_ "$Id: AddrGen.h,v 1.1.2.1 1998/09/22 07:43:53 rousskov Exp $"

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "Address.h"

// generates (host name, port number) pairs
// gen() method must be non-blocking and
//       return false if no more addresses can be generated

class AddrGen {
	public:
		virtual ~AddrGen() {}

		virtual AddrGen *clone() const = 0;
		virtual bool gen(Address &addr) = 0;
};

#endif
