#ifndef _BLOCK_READER_H_
#define _BLOCK_READER_H_ "$Id: BlockReader.h,v 1.8.2.2 1998/11/17 20:54:57 rousskov Exp $"

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "Size.h"
#include "XactReadThread.h"

// reads up-to a block of data at a time
class BlockReader: public XactReadThread {
	public:
		BlockReader(Size aBlockSize): theBlockSize(aBlockSize) {}

		virtual Thread *clone() const { return new BlockReader(theBlockSize); }

		virtual void init() { XactReadThread::init(); if (theConn) workBuf().minCapacity(theBlockSize); }

		virtual const char *name() const { return "BlockReader"; }

	protected:
		virtual void doIO();

	protected:
		Size theBlockSize;
};

#endif
