// $Id: Stack.h,v 1.1.2.1 1998/09/22 07:44:28 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef _STACK_H_
#define _STACK_H_

#include "Array.h"

// Stack (implemented via Array)

template <class Item>
class Stack: public Array<Item> {
	public:
		Stack(int aCapacity = 0): Array<Item>(aCapacity) {}

		const Item &top() const { return theItems[theCount-1]; }
		Item &top() { return theItems[theCount-1]; }
		Item pop() { return theItems[--theCount]; }
		void push(const Item &i) { append(i); }
};

#endif
