// $Id: readTCS.cc,v 1.1.2.1 1998/09/22 07:43:51 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

// a wrapper around rdtsc assembly instruction to read Time Stamp Counter,
// a CPU-internal-64bit-integer which is increased by 1 every clock-cycle
// on Pentium CPUs. 
// Theoretically, there should be X*10^6 increases on X MHz machine.

#include <sys/types.h>
#include <sys/time.h>
#include <stdlib.h>
#include <unistd.h>

#include <iostream.h>
#include <iomanip.h>



// Read the Pentium TSC
static inline 
u_int64_t readTSC() {
	u_int64_t cycles;
	// volatile is to prevent relocation in the code
	__asm __volatile(".byte 0x0f, 0x31" : "=&A" (cycles));
	return cycles;
}

// prints the number of cycles per "second"
int main(int argc, char *argv[]) {

	for (int i = atoi(argv[argc-1]); i > 0; --i) {
		u_int64_t start = readTSC();
		sleep(1);
		u_int64_t end = readTSC();
		cout << setw(13) << (end-start) << endl;
	}
}
